.include "m8def.inc"

.org 0x0
    RJMP  start
    
.org OVF0addr
rjmp timer_handler_4_times_per_line

;.org SPIaddr
.org URXCaddr
rjmp keyboard_key_irq_handler
;reti

.equ linecount=20 ;wird nicht ueberall benutzt
.equ hsynclen=40 ; (256 TZ)
.equ vsynclen=432 ; (256 TZ)
.equ trabantlen=40
.equ linelen=1024; (1024 TZ)
.equ synclines=50; Zeilen vor Bild um Jitter auszugleichen
.equ verschieben_v=-50;Positiv-> nach unten

.org $013
reti
.org $020
start:
    ; Stack Pointer setzen
    LDI	r17, low(RAMEND)  
    OUT	SPL,r17
    LDI	r17, high(RAMEND)
    OUT	SPH,r17
    ;Portrichtungen setzen
    LDI	r17,1 ; Bit 0 auf Ausgang, Rest auf Eingang
    OUT	DDRB,r17
    LDI	r17,32 ; Bit 5 auf Ausgang, 
    OUT	DDRC,r17
    
    ;Cursor auf 0:0
    LDI r18,0  
    STS text_pos_x,r18
    STS text_pos_y,r18
    
    ;Line_pointers setzen
    LDI	xh,high(line_pointers)
    LDI	xl,low(line_pointers)

    LDI r17,low(line_00)
    st	X+,r17
    LDI	r17,high(line_00);
    st X+,r17
    
    LDI r17,low(line_01)
    st	X+,r17
    LDI	r17,high(line_01);
    st X+,r17
    
    LDI r17,low(line_02)
    st	X+,r17
    LDI	r17,high(line_02);
    st X+,r17
    
    LDI r17,low(line_03)
    st	X+,r17
    LDI	r17,high(line_03);
    st X+,r17
    
    LDI r17,low(line_04)
    st	X+,r17
    LDI	r17,high(line_04);
    st X+,r17
    
    LDI r17,low(line_05)
    st	X+,r17
    LDI	r17,high(line_05);
    st X+,r17
    
    LDI r17,low(line_06)
    st	X+,r17
    LDI	r17,high(line_06);
    st X+,r17
    
    LDI r17,low(line_07)
    st	X+,r17
    LDI	r17,high(line_07);
    st X+,r17
    
    LDI r17,low(line_08)
    st	X+,r17
    LDI	r17,high(line_08);
    st X+,r17
    
    LDI r17,low(line_09)
    st	X+,r17
    LDI	r17,high(line_09);
    st X+,r17
    
    LDI r17,low(line_10)
    st	X+,r17
    LDI	r17,high(line_10);
    st X+,r17
    
    LDI r17,low(line_11)
    st	X+,r17
    LDI	r17,high(line_11);
    st X+,r17
    
    LDI r17,low(line_12)
    st	X+,r17
    LDI	r17,high(line_12);
    st X+,r17
    
    LDI r17,low(line_13)
    st	X+,r17
    LDI	r17,high(line_13);
    st X+,r17
    
    LDI r17,low(line_14)
    st	X+,r17
    LDI	r17,high(line_14);
    st X+,r17
    
    LDI r17,low(line_15)
    st	X+,r17
    LDI	r17,high(line_15);
    st X+,r17
    
    LDI r17,low(line_16)
    st	X+,r17
    LDI	r17,high(line_16);
    st X+,r17
    
    LDI r17,low(line_17)
    st	X+,r17
    LDI	r17,high(line_17);
    st X+,r17
    
    LDI r17,low(line_18)
    st	X+,r17
    LDI	r17,high(line_18);
    st X+,r17
    
    LDI r17,low(line_19)
    st	X+,r17
    LDI	r17,high(line_19);
    st X+,r17
    
    ;timer auf alle 256 TZ setzen	
    LDI	r17,1; TCCR0 CS02:0 kein Vorteiler
    OUT	TCCR0,r17
    
    LDI	r17,1 ;TOIE0 Timer0 Overflow Interrupt Enable
    OUT	TIMSK,r17
    
    LDI r17,0 ;
    OUT	GICR,r17; Keine externen Interrupts.
    
    ;Stromspaarmodus (geht noch nicht!)
    IN r17,MCUCR
    ANDI r17,0x0f ;SE -SM0 ausmaskieren
    ORI	r17,0x80 ;einschalten Modus idle
    OUT	MCUCR,r17 
    
    ;Tastaturinit allgemein
    LDI r17,0
    STS shift_state,r17
    STS key_buffer,r17
    ;Tastaturinit usart
    LDI r17,$00 ;Statusregister, so dass U2x=0 ist
    OUT UCSRA,r17
    LDI r17,(1<<rxen)+(1<<rxcie)
    OUT UCSRB,r17 ; Empfangsinterrupt und Empfang einschalten
    LDI r17,$f6;+(1<<ursel) ; Synchoner Modus 8 Bit Paritaet
    OUT UCSRC,r17
    LDI	r17,0 ; Bit 0 und 4 auf Eingang 
    OUT	DDRD,r17

   ;Tastaturinit SPI
;    LDI r17,$E0
;    OUT SPCR,r17    

        
    sei ;Interrupts global freischalten

    
    jmp	main ; zu main springen
    ;Testprogramm nach main
    LDI r17,0
    test:
      inc r17
      out Portb,r17
    rjmp test



.dseg
.org 0x60 ;Beginn des Arbeitsspeichers
line_00: .byte 40
line_01: .byte 40
line_02: .byte 40
line_03: .byte 40
.org 256
line_04: .byte 40
line_05: .byte 40
line_06: .byte 40
line_07: .byte 40
line_08: .byte 40
line_09: .byte 40
;16 bytes frei
line_counter: .byte 1 ;zaehlt runter bis auf 0
line_mode:    .byte 1  ;gibt den Modus an
time:         .byte 1  ; general time counter used by delay
text_pos_x:   .byte 1 ; Spalte des Cursors
text_pos_y:   .byte 1 ; Zeile des Cursors
timer_counter: .byte 1 ; Zaehlt 4 mal pro Zeile
random_number: .byte 1 ; Enthaelt irgendwelche Zufallszahlen
shift_state: .byte 1 ; shift state
key_buffer: .byte 1 ; Key buffer contains ASCII-representation of key 0 if no keypress
.org 512
line_10: .byte 40
line_11: .byte 40
line_12: .byte 40
line_13: .byte 40
line_14: .byte 40
line_15: .byte 40
;16 bytes frei
.org 768
line_16: .byte 40
line_17: .byte 40
line_18: .byte 40
line_19: .byte 40
line_buffer: .byte 40
line_pointers: .byte linecount*2
;16 bytes frei
.org 1024


.cseg



.equ video=PORTB

.macro sleep_r17 ; wartet r17*4-1 TZ
     sleep_r17_loop:
      DEC r17 ; 1 TZ
      CPI r17,0 ;1 TZ
      BRNE sleep_r17_loop ;2 TZ
.endmacro

.macro syncein ;2 TZ
     CBI PORTC,5
.endmacro

.macro syncaus ;2TZ
     SBI PORTC,5
.endmacro

.macro syncimpuls ;laenge in r17 in TZ/4
    syncein
    sleep_r17
    syncaus
.endmacro

.macro hsync ; 44
    LDI r17,hsynclen/4
    syncimpuls
.endmacro 

.macro vsync
    push r17
    LDI r17,108
    CBI	PORTC,4
    syncimpuls
    SBI	PORTC,4
    pop	r17
.endmacro 
   
    
.macro trabant
    push r17
    LDI r17,trabantlen/4
    syncimpuls
    pop r17
.endmacro


;Interrupthandler Dokumentation:
; M   C
; 5   5 mal Vortrabenten
; 4   5 mal Synchronisier-Impulse
; 6   5 mal Nachtrabanten
; 1   X mal jeden zweiten Interrupt
; 3   160 Zeilen (bei 20 Textzeilen)
; 2   X mal jeden zweiten Interrupt

timer_handler_4_times_per_line:
	push 	r18
	PUSH 	r19
	IN	r19,SREG
	cli
	LDS	r18,timer_counter
	inc	r18
	STS	timer_counter,r18
	ANDI	r18,1
	CPI	r18,0
	BRNE	timer_handler_4_times_per_line_end
	call	handler_twice_per_line
	
   timer_handler_4_times_per_line_end:	
        
	sei
	OUT	SREG,r19
	POP	r19
	pop	r18
	reti

timer_handle_state_table: 
  .db 1,1    ; von 0 auf unteren weissen Bereich unbenutzt
  .db 3,1    ; von 1 auf Bild
  .db 5,5    ; von 2 auf 5 5x
  .db 2,109-verschieben_v  ; von 3 (Bild) auf 2 140 Halbzeilen
  .db 6,5    ; von 4 (vsync) auf 6 Nachtrabanten
  .db 4,5    ; von 5 (vortrabanten) auf 4 vsync
  .db 1,514-synclines*2-linecount*16+verschieben_v  ; von 6 (Nachtrabanten) auf 1 oberer leerer Bereich
	

handler_twice_per_line: 
	push 	r18
	push 	r19
	push	r20
	push 	r17
	
	LDS	r18, line_counter
	LDS	r19, line_mode
	
	DEC	r18
	
	;rjmp isr_3
	
	CPI	r19,3
	BRLT	isr_1_2
	CPI	r19,3
	BREQ	isr_3
	CPI	r19,4
	BREQ	isr_4
	CPI	r16,7
	jmp	isr_5_6
	hsync
	hsync
	JMP	isr_ende	
    
    isr_1_2: ;einer der leeren Bereiche
	mov	r20,r18
	andi	r20,1    ; Bit 0 rausmaskieren
	CPI	r20,0
	BREQ	isr_ende ; Bei jedem zweiten Mal raus
	hsync
	jmp isr_ende
	
    isr_3:
        nop       ; Fuer Timing
	hsync     ; hsync
	call drawimage	;Bild ausgeben!!!
	call count_time ;Zeit zaehlen
	call  count_random_number ;Zufallszahlen verarbeiten

	jmp	isr_ende
    
    isr_4: ; vsync
	vsync          
	jmp	isr_ende

    isr_5_6:
	trabant ; Trabant
	LDS	r20,timer_counter
	inc	r20
	STS	timer_counter,r20
	
	;LDI r18,0
    	;STS timer_counter,r18        
    isr_ende:
        CPI	r18,0
	BRNE	isr_ende2  
	CPI	r19,7      ; Schauen ob Modus<7  
	BRLT	isr_ende3  ; Wenn ja, OK
	LDI	r19,1	   ;sonst modus=1  (Damit Verhalten definiert wird)
    isr_ende3: ; laed neue Werte fuer den Modus und den Zaehler
	push	Zl
	push	zh
	LDI r20,0
	LDI	zl, low(timer_handle_state_table*2)
	LDI	zh,high(timer_handle_state_table*2)
	add	zl,r19
	add	zl,r19
	LPM	r19,Z+
	LPM	r18,Z
	pop 	zh
	pop	zl	
	

    isr_ende2: 	; alles OK, ret
	STS	line_counter, r18
	STS	line_mode, r19
	pop	r17
	pop	r20
	pop	r19
	pop	r18
      ret




; Zu tun
;  Leerzeilen vor Bild ausgeben
;  Sync-anpassen
;  Stack-Bereich abschätzen
;  Cursor!


.macro outchar	
    LD	r1,X+		;2
    OUT	video,r1	;1 0
    LSR	r1		;1
    OUT video,r1	;1 1
    LSR r1		;1
    OUT video,r1       ;1 2
    LSR r1		;1
    OUT video,r1       ;1 3
    LSR r1		;1
    OUT video,r1       ;1 4 
    LSR r1		;1 #12
    OUT video,r1       ;1 5 
    LSR r1		;1
    OUT video,r1       ;1 6 
    LSR r1		;1
    OUT video,r1       ;1 7
                        ; 17 TZ
.endmacro

.macro line
    LDI xh,high(line_buffer) 	;1  X auf Zeilenbuffer
    LDI xl,low(line_buffer)	;1
    ;LDI	xh,0
    ;LDI	xl,0
  
    outchar
    outchar
    outchar
    outchar
    outchar ;#5
    outchar
    outchar
    outchar
    outchar
    outchar ;#10
    outchar 
    outchar
    outchar
    outchar
    outchar ;#15
    outchar
    outchar
    outchar
    outchar
    outchar ;#20
    outchar
    outchar
    outchar
    outchar
    outchar ;#25
    outchar
    outchar
    outchar
    outchar
    outchar ;#30
    outchar
    outchar
    outchar
    outchar
    outchar ;#35
    outchar
    outchar
    outchar
    outchar
    outchar ;#40
    CBI	video,0
    ;#17*40+4=684
.endmacro			
			
.macro chargen
       LD Zl,Y+       ;#2 TZ   Y ist Zeiger auf Buchstabe
       LPM r1,Z       ;#3 TZ   Z ist Zeiger auf Zeichensatz
       ST X+,r1       ;#2 TZ   X ist Bitmapbuffer
      ;#7 TZ
.endmacro

.macro chargen_40char
    LDI xh,high(line_buffer) 	;1  X auf Zeilenbuffer
    LDI xl,low(line_buffer)	;1
    chargen
    chargen
    chargen
    chargen
    chargen ;#5
    chargen
   syncein  ;TZ 44
    chargen
    chargen
    chargen
    chargen ;#10
    chargen
    chargen
  syncaus    
    chargen
    chargen
    chargen ;#15
    chargen
    chargen
    chargen
    chargen
    chargen ;#20
    chargen
    chargen
    chargen
    chargen
    chargen ;#25
    chargen
    chargen
    chargen
    chargen
    chargen ;#30
    chargen
    chargen
    chargen
    chargen
    chargen ;#35
    chargen
    chargen
    chargen
    chargen
    chargen ;#40
    ;#40*7+2+2+1+1=286
.endmacro


textline:
    chargen_40char    ;#280 TZ
    
    line              ;#682 TZ
    CBI video,0	      ;2
    ret		      ;#4 TZ
                     ;########TZ neu berechnen###
    
delay_10_tz: ;4 fuer call 4 fure ret
    nop
    nop
    ret    
    
drawimage:  ;  4 fuer Call
    PUSH r17  ;2
    PUSH r18  ;2
    PUSH r1   ;2
    
    PUSH xh   ;2
    PUSH xl   ;2
    PUSH yh   ;2
    PUSH yl   ;2
    PUSH zh   ;2
    PUSH zl   ;2
              ;=22 TZ 
    ; Synkronisationsimpulse vor dem Bild
    ; wegen Jitter
    ;jmp imagestart ;zumTest
    
        
    ldi	r18,synclines ;Anzahl der Zeilen vor dem Bild ;23 TZ nach hsyncende=67 seit hsync Anfang
  drawimage_vorzeile1:
    ldi	r17,229 ;\ 223*4 Taktzyklen warten
    sleep_r17   ; \
    nop         ; / 892
;    nop     ;/
    dec	r18
    ;62 TZ zu hsync
    BREQ imagestart      ;	r18=0!
    ;61 TZ zu hsync
    ldi r17,14 ;60 TZ
    sleep_r17
    ;nop
    hsync      ;44 TZ
    ;ldi r17,5 ;\
    ;sleep_r17 ;/ 20 TZ
    jmp	drawimage_vorzeile1 ;3 TZ
    
  imagestart:; 60 TZ zu hsync    
    LDI	r18,0
  linestart: ;von hier in 59 TZ hsyncbeginn
    mov	r17,r18                   	;1
    LSR	r17 ; \                   	;1
    LSR	r17 ;  >/8                	;1
    LSR r17 ; /				;1
    LSL r17 ; *2			;1
    LDI	zh,high(line_pointers)		;1
    LDI zl,low(line_pointers)		;1
    ADD zl,r17				;1
    LD yl,Z+				;2
    LD yh,Z				;2
    mov r17,r18				;1
    ANDI r17,7				;1
    LDI zh,high(font_rom*2)		;1
    add zh,r17				;1
    chargen_40char			;286 sync ; sync nach 44 TZ
    line				;684
;-------------------------------
        ;32 TZ frei evtl Cursor noch machen, dann sleep kuerzer
    LDI r17,8
    sleep_r17    
;---------------------------	
    
    inc r18				;1
    CPI r18,linecount*8			;1
    BREQ ende				;1/2
    jmp linestart			;3
                                        ;Summe: 1024
  ende:
    ldi r17,64 ;damit naechsterIRQ passt
    sleep_r17
    POP zl
    POP zh
    POP yl
    POP yh
    POP xl
    POP xh
    POP r1
    POP r18
    POP r17
    ret  



    
;#####################################################################################
;## 										    ##
;##	Textausgabe Routinen							    ##
;## 										    ##
;#####################################################################################

; Name			Geschrieben	Getestet	Dokumentiert
; clear_line_r17	OK
; clear_screen		OK
; scroll_up	
; out_char_r17
; text_cr_lf		OK


clear_line_r17: ;Loescht die Zeile in r17
    push xh
    push xl
    push r18
    push r19
    LDI	xh,high(line_pointers) 
    LDI	xl,low(line_pointers)  
    ADD xl,r17
    ADD xl,r17
    
    LD	r18,X+  ; low byte der Adresse
    LD r19,X    ; high byte der Adresse
    
    MOV Xl,r18
    MOV xh,r19
    
    LDI r19,32 ; 32=Leerzeichen!!!
    LDI r18,40
  clear_line_r17_loop:
    ST	X+,r19
    DEC r18
    BRNE clear_line_r17_loop    
    
    pop r19
    pop r18
    pop xl
    pop xh
    ret
    
clear_screen: ; loescht den Bildschirm setzt Cursor auf 0:0
    push r17
    LDI r17,linecount
   clear_screen_loop:
    dec r17
    call clear_line_r17
    CPI	r17,0
    BRNE clear_screen_loop
    LDI r17,0  
    STS text_pos_x,r17
    STS text_pos_y,r17
    pop	 r17
    ret
    
scroll_up:  ; schiebt den Bildschirm nach oben
    push r17
    push r18
    push r19
    push r20
    push r21
    push Xl
    push Xh
    push yl
    push yh
      LDI xl,low(line_pointers)
      LDI xh,high(line_pointers)
      LDI yl,low(line_pointers)
      LDI yh,high(line_pointers)
      LD  r18,X+
      LD  r19,X+
      LDI r17,linecount-1
    scroll_up_next_line:
       LD  r20,X+    
       LD  r21,X+
       ST  Y+,r20
       ST  Y+,r21
       DEC r17
       CPI r17,0
       BRNE scroll_up_next_line   
      ST  Y+,r18
      ST  Y+,r19
    pop yh
    pop yl
    pop Xh
    pop Xl
    pop r21
    pop r20
    pop r19
    pop r18
    pop r17
    ret

scroll_down:  ; schiebt den Bildschirm nach unten
    push r17
    push r18
    push r19
    push r20
    push r21
    push Xl
    push Xh
    push yl
    push yh
      LDI xl,low(line_pointers+linecount*2)
      LDI xh,high(line_pointers+linecount*2)
      LD  r18,-X ;Adresse der untersten Zeile sichern
      LD  r19,-X
      LDI yl,low(line_pointers+linecount*2)
      LDI yh,high(line_pointers+linecount*2)
      LDI r17,linecount-1
    scroll_down_next_line:
       LD  r20,-X    
       LD  r21,-X
       ST  -Y,r20
       ST  -Y,r21
       DEC r17
       CPI r17,0
       BRNE scroll_down_next_line   
      ST  -Y,r18
      ST  -Y,r19
    pop yh
    pop yl
    pop Xh
    pop Xl
    pop r21
    pop r20
    pop r19
    pop r18
    pop r17
    ret

    
text_cr_lf: ; Wagenruecklauf Zeilenschaltung    
    PUSH r17
    LDI	r17,0
    STS	text_pos_x,r17 
    LDS	r17,text_pos_y
    inc r17
    CPI r17,20
    BRLT text_cr_lf_ende
    CPI r17,19
    call scroll_up
    LDI r17,0  
    STS text_pos_x,r17
    LDI	r17,linecount-1
    STS text_pos_y,r18
    call clear_line_r17
  text_cr_lf_ende:    
    STS text_pos_y,r17
    POP r17
    ret    

.include "keycodes.asm"

    
get_char_pointer_x: ;makes x point to the character position in memory
    PUSH r18
    PUSH yl
    PUSH yh
    
    LDS	r18,text_pos_y
    LDI yh,high(line_pointers)
    LDI yl,low(line_pointers)
    ADD yl,r18
    ADD yl,r18 
    LD xl,Y+ 
    LD xh,Y
    LDS r18,text_pos_x
    ADD xl,r18
    
    POP yh
    POP yl
    POP r18
    ret    
    
    
out_char_r17: ;gibt Zeichen in r17 aus r17 bleibt erhalten
    PUSH xh
    PUSH xl
    
    call get_char_pointer_x
    
    ST	X,r17
    
    LDS xl,text_pos_x
    inc xl
    STS text_pos_x,xl
    
    CPI xl,40             ;Anzahl Spalten
    BRLT out_char_r17_end
    call text_cr_lf
  out_char_r17_end:    
    POP xl
    POP xh
    ret

get_char_r17: ;holt Zeichen auf Cursorposition. Aendert Position nicht
    PUSH xh
    PUSH xl
    call get_char_pointer_x
    LD r17,X
    POP xl
    POP xh
    ret
    
write_string_z_pm: ;Schreibt nullterminierte Zeichenkette im ROM, Zeiger in Z, steht dann auf 0-Byte
    PUSH r17
   write_string_z_pm_loop:    
      LPM r17,Z+
      CPI r17,0
      BREQ write_string_z_pm_ende
      call out_char_r17
      rjmp write_string_z_pm_loop
   write_string_z_pm_ende:      
    POP r17    
    ret

    
count_time: ;to be called 50 times a second
    PUSH	r17
    LDS		r17,time
    inc		r17
    STS		time,r17
    POP		r17
    ret
    
sleep_01s: ;sleeps for 0.1 seconds; 5 frames
    PUSH	r17
    LDI		r17,0
    STS		time,r17
  sleep_01s_loop:
    sleep	;Um Strom zu sparen
    ;power save
     NOP
     NOP
     NOP
    LDI	r17,250
   sleep_01s_loop2:
    nop
    nop
    nop
    nop
    nop
    DEC	r17
    CPI	r17,0
    BRNE sleep_01s_loop2
         
    LDS		r17,time
    CPI		r17,5
    BRLT	sleep_01s_loop
        
    POP		r17
    ret
    
count_random_number: ;bearbeitet beliebige Zahlen
    PUSH r19
    PUSH r18
      LDS r19,random_number
      EOR r19,r20       ;  Get in random data from r20
      LDS r18,time
      EOR r19,r18
      ROL r19
      EOR r18,r19
      ROL r19
      ROL r19
      STS random_number,r19
    POP r18
    POP r19     
  ret    


get_random_number_r17: ;besorgt eine beliebige Zahl
    LDS r17,random_number
    ROR r17
    STS random_number,r17
  ret 

hexdigit_to_ascii_r17: ;changes the hex digit in the lower 4 bits of r17 to it's ASCII representation
    andi r17,$0f
    subi r17,$ff-$2f ;0-9
    CPI r17,$3A
    BRLT hexdigit_to_ascii_end
    subi r17,$ff-6 ; A-F
    hexdigit_to_ascii_end:
  ret




keyboard_key_irq_handler:
  ;shift state  76543210
  ;             |||||||+ shift
  ;             ||||||+
  ;          	|||||+
  ;		||||+
  ;		|||+
  ;		||+
  ;		|+
  ;		+ break code 
    push 	r18
    PUSH 	r19
    IN	r19,SREG  
    PUSH r17
    PUSH zh
    PUSH zl
    PUSH r20
    
    LDS r18,shift_state
  keyboard_key_irq_handler_start:
    in r17,UDR
;;   in r17,SPDR
    
;;;    call out_char_r17 ;;test
    
    cp r20,r17
    call count_random_number
    
    CPI r17,$FA ;drop FAs
    BREQ keyboard_key_irq_handler_end
    
    CPI r17,$E0 ;drop E0s
    BREQ keyboard_key_irq_handler_end
    
    CPI r17,$f0 ;break code?
    BREQ keyboard_key_irq_handler_break_code
    ;get normal key
    mov r20,r18
    ANDI r20,$7f
    LDI zh,high(keycodes_shift*2)
    LDI	zl,low(keycodes_shift*2) 
    CPI r20,1
    BREQ keyboard_key_irq_handle_shift
    LDI zh,high(keycodes_normal*2)
    LDI	zl,low(keycodes_normal*2)    
   keyboard_key_irq_handle_shift:
    LDI r20,0
    add zl,r17  ;ueberlauf notwendig!
    adc zh,r20
    LPM r17,Z
    
    CPI r17,1 ;shift?
    BREQ keyboard_key_irq_handler_shift
    
    mov zl,r18
    ANDI zl,$80 ;break code
    CPI zl,$80
    BREQ keyboard_key_irq_handler_end    
;    CPI r17,kret
;    BREQ keyboard_key_irq_handler_return
;    call out_char_r17
    STS key_buffer,r17
    rjmp keyboard_key_irq_handler_end
   keyboard_key_irq_handler_return:
    call text_cr_lf
    rjmp keyboard_key_irq_handler_end
  keyboard_key_irq_handler_shift:    
    mov zl,r18
    ANDI zl,$80 ;break code
    CPI zl,$80
    BREQ keyboard_key_irq_handler_shift_off    
    LDI r18,1
    rjmp keyboard_key_irq_handler_end
   keyboard_key_irq_handler_shift_off:
    LDI r18,0 
    rjmp keyboard_key_irq_handler_end
  keyboard_key_irq_handler_break_code: ;break code
    ORI r18,$80
    rjmp keyboard_key_irq_handler_end2
  keyboard_key_irq_handler_end:
    ANDI r18,$7f ;break code off
  keyboard_key_irq_handler_end2:
    sbic  UCSRA,RXC ;still bytes in buffer?
    rjmp keyboard_key_irq_handler_start ;if yet do it again
    STS shift_state,r18
    POP r20
    POP zl
    POP zh
    POP r17
    OUT	SREG,r19
    POP	r19
    pop	r18      
  reti

get_key_r17: ;gets the current key in r17
    LDS r17,key_buffer
    CPI r17,0
    BREQ get_key_r17_end ; exit when no key is pressed
    PUSH r17
      LDI r17,0
      STS key_Buffer,r17
    POP r17
    get_key_r17_end:
  ret

read_line_x_r18: ;reads/edits the line at RAM position x, max length in r18
   PUSH r17
   PUSH yl    
   PUSH yh
   push zl
   push zh
   PUSH r19    ; character under cursor + temp
   PUSH r20    ;Position 0.. r18-1
   PUSH r21    ;temp register
   mov yl,xl
   mov yh,xh
   LDI r20,0
  read_line_x_r18_start: 
   mov yh,xh ;Put Y to the current char
   mov yl,xl
   add yl,r20
        
   LD r19,Y
   read_line_x_r18_waitkeyloop:
      LDS r21,time
      ANDI r21,8
      LDI r17,'_'
      CPI r21,0
      BREQ read_line_x_r18_nocursor
        ST Y,r17
      read_line_x_r18_nocursor:	
      call get_key_r17
      ST Y,r19
      CPI r17,0
     BREQ read_line_x_r18_waitkeyloop
   CPI r17,kret        ; Enter Taste?
   BREQ read_line_x_r18_end ;  dann raus
   CPI r17,kbsp        ; Rueckschritt Taste?
   BREQ read_line_x_r18_backspace
   CPI r17,kleft
   BREQ read_line_x_r18_kleft ;Taste links

   CP r20,r18 ; right border
   BREQ read_line_x_r18_start ; ignore key press
   CPI r17,kright
   BREQ read_line_x_r18_kright ; Taste rechts     
   ; normale Taste
   inc r20
   ST Y,r17
   rjmp read_line_x_r18_start     
     
  read_line_x_r18_backspace:
   CPI r20,0                 ; ganz links
   BREQ read_line_x_r18_start ; dann raufspringen
   mov zh,yh ;Put Z to the current char
   mov zl,yl
   subi zl,1 ; Put Z to char left of cursor
   mov r21,r20
   dec r20 ;move sursor to the left
  read_line_x_r18_backspace_loop: 
   LD r19,Y+
   ST Z+,r19
   inc r21
   CP r18,r21 ;If you have moved to the last character stop
   BRLT read_line_x_r18_backspace_end      
   CPI r19,0   ;                       Keine Null
   BRNE read_line_x_r18_backspace_loop ; Nochmal
   read_line_x_r18_backspace_end:
   LDI r19,0
   ST Z,r19 ; fill up with 0     
  rjmp read_line_x_r18_start; go up again     
  read_line_x_r18_kleft:
   CPI r20,0    ; left border
   BREQ read_line_x_r18_start ;go up again
   dec r20
   rjmp read_line_x_r18_start
  read_line_x_r18_kright:
    inc yl
    LD r19,Y
    CPI r19,0
    BREQ read_line_x_r18_start ;won't go to zerocharacter
    inc r20
    rjmp read_line_x_r18_start     
  rjmp read_line_x_r18_start
  read_line_x_r18_end:
   POP r21
   POP r20
   POP r19
   POP zh
   POP zl
   POP yh
   POP yl
   POP r17
  ret
  
  

;#### Hauptprogramm###
.include	"main.asm" ; main.asm enthaelt Hauptprogramm
romtop:




;Zeichensatz 256 Zeichen a 8x8    
;.org 6144 ;2 Kilobyte vor Ende des ROMs    
.org FLASHEND-(8*256)/2+1
.include "char_rom.asm"    
